## nheko 0.12.0+~0.10.0+~1.0.0+~0.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13..3.21)

option(APPVEYOR_BUILD "Build on appveyor" OFF)
option(CI_BUILD "Set when building in CI. Enables -Werror where possible" OFF)
option(ASAN "Compile with address sanitizers" OFF)
option(QML_DEBUGGING "Enable qml debugging" OFF)
if(UNIX AND NOT APPLE)
    option(MAN "Build man page" ON)
else()
    option(MAN "Build man page" OFF)
endif()
option(FLATPAK "Set this only if Nheko is built as a flatpak" OFF)
option(JSON_ImplicitConversions "Disable implicit conversions in nlohmann/json" ON)

set(
    CMAKE_TOOLCHAIN_FILE "${CMAKE_CURRENT_LIST_DIR}/toolchain.cmake"
    CACHE
    FILEPATH "Default toolchain"
)
set(CMAKE_CXX_STANDARD 20 CACHE STRING "C++ standard")
set(CMAKE_CXX_STANDARD_REQUIRED ON CACHE BOOL "Require C++ standard to be supported")
set(CMAKE_POSITION_INDEPENDENT_CODE ON CACHE BOOL "compile as PIC by default")
set(CMAKE_OSX_DEPLOYMENT_TARGET "10.15" CACHE STRING "macos deployment target")

option(HUNTER_ENABLED "Enable Hunter package manager" OFF)
include("cmake/HunterGate.cmake")
HunterGate(
    URL "https://github.com/cpp-pm/hunter/archive/v0.25.5.tar.gz"
    SHA1 "a20151e4c0740ee7d0f9994476856d813cdead29"
    LOCAL
)

macro(hunter_add_package_safe)
    set(pkg_temp_backup_libdir "$ENV{PKG_CONFIG_LIBDIR}")
    set(pkg_temp_backup_path "$ENV{PKG_CONFIG_PATH}")
    hunter_add_package(${ARGV})
    if("${pkg_temp_backup_path}" STREQUAL "")
        unset(ENV{PKG_CONFIG_PATH})
    else()
        set(ENV{PKG_CONFIG_PATH} "${pkg_temp_backup_path}")
    endif()
    if("${pkg_temp_backup_libdir}" STREQUAL "")
        unset(ENV{PKG_CONFIG_LIBDIR})
    else()
        set(ENV{PKG_CONFIG_LIBDIR} "${pkg_temp_backup_libdir}")
    endif()
    message("pkg_conf_path: '$ENV{PKG_CONFIG_PATH}', pkg_conf_libdir: '$ENV{PKG_CONFIG_LIBDIR}'")
endmacro()

project(nheko LANGUAGES CXX C)

option(USE_BUNDLED_SPDLOG "Use the bundled version of spdlog." ${HUNTER_ENABLED})
option(USE_BUNDLED_OLM "Use the bundled version of libolm." ${HUNTER_ENABLED})
option(USE_BUNDLED_GTEST "Use the bundled version of Google Test." ${HUNTER_ENABLED})
option(USE_BUNDLED_CMARK "Use the bundled version of cmark." ${HUNTER_ENABLED})
option(USE_BUNDLED_JSON "Use the bundled version of nlohmann json." ${HUNTER_ENABLED})
option(USE_BUNDLED_OPENSSL "Use the bundled version of OpenSSL." OFF)
option(USE_BUNDLED_MTXCLIENT "Use the bundled version of the Matrix Client library." ${HUNTER_ENABLED})
option(USE_BUNDLED_LMDB "Use the bundled version of lmdb." ${HUNTER_ENABLED})
option(USE_BUNDLED_LMDBXX "Use the bundled version of lmdb++." ${HUNTER_ENABLED})
option(USE_BUNDLED_QTKEYCHAIN "Use the bundled version of Qt6Keychain." ${HUNTER_ENABLED})
option(USE_BUNDLED_COEURL "Use a bundled version of the Curl wrapper"
    ${HUNTER_ENABLED})
option(USE_BUNDLED_LIBEVENT "Use the bundled version of libevent." ${HUNTER_ENABLED})
option(USE_BUNDLED_LIBCURL "Use the bundled version of libcurl." ${HUNTER_ENABLED})
option(USE_BUNDLED_RE2 "Use the bundled version of re2." ${HUNTER_ENABLED})
option(USE_BUNDLED_KDSINGLEAPPLICATION "Use the bundled version of KDSingleApplication." ${HUNTER_ENABLED})
option(USE_BUNDLED_CPPHTTPLIB "Use the bundled version of cpp-httplib." ON)
option(USE_BUNDLED_BLURHASH "Use the bundled version of blurhash." ON)

include(CMakeDependentOption)
set(VOIP_DEFAULT ON)
if(APPLE OR WIN32 OR HAIKU)
    set(VOIP_DEFAULT OFF)
endif()
option(VOIP "Whether to enable voip support. Disable this, if you don't have gstreamer." ${VOIP_DEFAULT})
set(X11_DEFAULT)
if(WIN32 OR APPLE OR HAIKU)
    set(X11_DEFAULT OFF)
endif()
option(X11 "Whether to enable X11 specific features (screenshare, window roles)." ${X11_DEFAULT})
cmake_dependent_option(SCREENSHARE_XDP "Whether to enable screenshare support using xdg-desktop-portal." ON "VOIP" OFF)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

if(${CMAKE_VERSION} VERSION_LESS "3.14.0")
    message("Adding FetchContent_MakeAvailable")
    # from cmakes sources
    macro(FetchContent_MakeAvailable)
        foreach(contentName IN ITEMS ${ARGV})
            string(TOLOWER ${contentName} contentNameLower)
            FetchContent_GetProperties(${contentName})
            if(NOT ${contentNameLower}_POPULATED)
                FetchContent_Populate(${contentName})

                # Only try to call add_subdirectory() if the populated content
                # can be treated that way. Protecting the call with the check
                # allows this function to be used for projects that just want
                # to ensure the content exists, such as to provide content at
                # a known location.
                if(EXISTS ${${contentNameLower}_SOURCE_DIR}/CMakeLists.txt)
                    add_subdirectory(${${contentNameLower}_SOURCE_DIR}
                        ${${contentNameLower}_BINARY_DIR})
                endif()
            endif()
        endforeach()
    endmacro()
endif()

# Include Qt basic functions
include(QtCommon)

include(GNUInstallDirs)

set(CPACK_PACKAGE_VERSION_MAJOR "0")
set(CPACK_PACKAGE_VERSION_MINOR "12")
set(CPACK_PACKAGE_VERSION_PATCH "0")
set(PROJECT_VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR})
set(PROJECT_VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR})
set(PROJECT_VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH})

# Set PROJECT_VERSION_PATCH & PROJECT_VERSION_TWEAK to 0 if not present
# Needed by add_project_meta.
fix_project_version()

# Set additional project information
set(COMPANY "Nheko")
set(COPYRIGHT "Copyright (c) 2024 Nheko Contributors")
set(IDENTIFIER "im.nheko.Nheko")

add_project_meta(META_FILES_TO_INCLUDE)

if(NOT MSVC AND NOT APPLE)
    set(THREADS_PREFER_PTHREAD_FLAG ON)
    find_package(Threads REQUIRED)
endif()

if(BUILD_DOCS)
    find_package(Doxygen)

    if(DOXYGEN_FOUND)
        set(DOXYGEN_IN ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Doxyfile.in)
        set(DOXYGEN_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

        configure_file(${DOXYGEN_IN} ${DOXYGEN_OUT})

        add_custom_target(docs ALL
            COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_OUT}
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
            COMMENT "Generating API documentation with Doxygen"
            VERBATIM )
    else(DOXYGEN_FOUND)
        message("Doxygen need to be installed to generate the doxygen documentation")
    endif(DOXYGEN_FOUND)
endif()

#
## coeurl
#
## Need to repeat all libevent deps?!?
if(USE_BUNDLED_LIBEVENT)
    hunter_add_package_safe(Libevent)
    find_package(Libevent CONFIG REQUIRED)
else()
    find_package(PkgConfig REQUIRED) 
    pkg_check_modules(libevent_core REQUIRED IMPORTED_TARGET libevent_core)
    if(WIN32)
        pkg_check_modules(libevent_windows REQUIRED IMPORTED_TARGET libevent_windows)
    else()
        pkg_check_modules(libevent_pthreads REQUIRED IMPORTED_TARGET libevent_pthreads)
    endif()
endif()

# curl
if(USE_BUNDLED_LIBCURL)
    hunter_add_package_safe(CURL)
    find_package(CURL CONFIG REQUIRED)
else()
    find_package(PkgConfig REQUIRED) 
    pkg_check_modules(libcurl REQUIRED IMPORTED_TARGET libcurl)
endif()

# spdlog
if(USE_BUNDLED_SPDLOG)
    hunter_add_package_safe(spdlog)
endif()
find_package(spdlog 1.0.0 CONFIG REQUIRED)

if(USE_BUNDLED_COEURL)
    include(FetchContent)
    FetchContent_Declare(
        coeurl
        GIT_REPOSITORY https://nheko.im/Nheko-Reborn/coeurl.git
        GIT_TAG        831e2ee8e9cf08ea1ee9736cde8370f9d0312abc
    )
    FetchContent_MakeAvailable(coeurl)
    set(COEURL_TARGET_NAME coeurl::coeurl)
else()
    find_package(PkgConfig)
    pkg_check_modules(coeurl IMPORTED_TARGET coeurl>=0.3.0)
    if(TARGET PkgConfig::coeurl)
        set(COEURL_TARGET_NAME PkgConfig::coeurl)
    endif()
endif()

if(NOT TARGET PkgConfig::coeurl)
    find_package(coeurl 0.2.1 CONFIG)
    if(TARGET coeurl::coeurl)
        set(COEURL_TARGET_NAME coeurl::coeurl)
    endif()
endif()

if(NOT COEURL_TARGET_NAME)
    message(ERROR "Couldn't find coeurl")
endif()

if(USE_BUNDLED_RE2)
    hunter_add_package(re2)
    find_package(re2 CONFIG REQUIRED)
else()
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(re2 REQUIRED IMPORTED_TARGET re2)
endif()

#
# LMDB
#
#include(LMDB)
if(USE_BUNDLED_LMDB)
    hunter_add_package_safe(lmdb)
    find_package(liblmdb CONFIG REQUIRED)

    target_include_directories(liblmdb::lmdb INTERFACE
        "${HUNTER_INSTALL_PREFIX}/include/lmdb")
else()
    find_package(LMDB REQUIRED)
endif()

#
# Discover Qt dependencies.
#
find_package(Qt6 6.5 COMPONENTS Core Widgets Gui LinguistTools Svg Multimedia Qml QuickControls2 REQUIRED)
find_package(Qt6DBus)

if(USE_BUNDLED_QTKEYCHAIN)
    include(FetchContent)
    set(BUILD_WITH_QT6 ON)
    FetchContent_Declare(
        qt6keychain
        GIT_REPOSITORY https://github.com/frankosterfeld/qtkeychain.git
        GIT_TAG        v0.14.0
    )
    set(BUILD_TEST_APPLICATION OFF CACHE INTERNAL "")
    FetchContent_MakeAvailable(qt6keychain)
else()
    find_package(Qt6Keychain REQUIRED)
endif()

if(USE_BUNDLED_KDSINGLEAPPLICATION)
    include(FetchContent)
    set(KDSingleApplication_QT6 ON CACHE BOOL INTERNAL)
    set(KDSingleApplication_EXAMPLES OFF CACHE BOOL INTERNAL)
    FetchContent_Declare(
        kdsingleapplication
        GIT_REPOSITORY https://github.com/KDAB/KDSingleApplication.git
        GIT_TAG        v1.0.0
    )
    FetchContent_MakeAvailable(kdsingleapplication)
else()
    find_package(KDSingleApplication-qt6 REQUIRED)
endif()

if(Qt6Widgets_FOUND)
    if(Qt6Widgets_VERSION VERSION_LESS 6.5.0)
        message(STATUS "Qt version ${Qt6Widgets_VERSION}")
        message(WARNING "Minimum supported Qt6 version is 6.5!")
    endif()
endif(Qt6Widgets_FOUND)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
if(NOT MSVC)
    set(
        CMAKE_CXX_FLAGS
        "${CMAKE_CXX_FLAGS} \
        -Wall \
        -Wextra \
        -pedantic \
        -fsized-deallocation \
        -fdiagnostics-color=always \
        -Wunreachable-code \
        -Wno-attributes"
    )
    if(NOT CMAKE_COMPILER_IS_GNUCXX)
        # -Wshadow is buggy and broken in GCC, so do not enable it.
        # see https://gcc.gnu.org/bugzilla/show_bug.cgi?id=79328
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wshadow")
    endif()
endif()

if(MSVC)
    set(
        CMAKE_CXX_FLAGS
        "${CMAKE_CXX_FLAGS} /bigobj"
    )
endif()

if(NOT (CMAKE_BUILD_TYPE OR CMAKE_CONFIGURATION_TYPES))
    set(CMAKE_BUILD_TYPE "Debug" CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
    message("Setting build type to '${CMAKE_BUILD_TYPE}'")
else(NOT (CMAKE_BUILD_TYPE OR CMAKE_CONFIGURATION_TYPES))
    message("Build type set to '${CMAKE_BUILD_TYPE}'")
endif(NOT (CMAKE_BUILD_TYPE OR CMAKE_CONFIGURATION_TYPES))

set(SPDLOG_DEBUG_ON false)

# Windows doesn't handle CMAKE_BUILD_TYPE.
if(NOT WIN32)
    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
        set(SPDLOG_DEBUG_ON true)
    else()
        set(SPDLOG_DEBUG_ON false)
    endif()
endif()

find_program(GIT git)
if(GIT)
    execute_process(
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        COMMAND ${GIT} rev-parse --short HEAD
        OUTPUT_VARIABLE GIT_OUT OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    if(GIT_OUT)
        set(CPACK_PACKAGE_VERSION_PATCH "${CPACK_PACKAGE_VERSION_PATCH}-${GIT_OUT}")
    else()
        set(CPACK_PACKAGE_VERSION_PATCH "${CPACK_PACKAGE_VERSION_PATCH}")
    endif()
endif(GIT)

set(CPACK_PACKAGE_VERSION ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH})
set(PROJECT_VERSION ${CPACK_PACKAGE_VERSION})

message(STATUS "Version: ${PROJECT_VERSION}")

cmake_host_system_information(RESULT BUILD_HOST QUERY HOSTNAME)

include(CheckSymbolExists)
check_symbol_exists(backtrace_symbols_fd "execinfo.h" HAVE_BACKTRACE_SYMBOLS_FD)

configure_file(cmake/nheko.h config/nheko.h)

#
# Declare source and header files.
#
set(SRC_FILES
    # Emoji
    src/emoji/Provider.cpp
    src/emoji/Provider.h
    src/emoji/Emoji.cpp
    src/emoji/Emoji.h

    # Timeline

=== Makefile ===
# Makefile for lmdb++ <http://lmdbxx.sourceforge.net/>

PACKAGE_NAME      := lmdb++
PACKAGE_TARNAME   := lmdbxx
PACKAGE_VERSION    = $(shell cat VERSION)
PACKAGE_STRING     = $(PACKAGE_NAME) $(PACKAGE_TARNAME)
PACKAGE_TARSTRING  = $(PACKAGE_TARNAME)-$(PACKAGE_VERSION)
PACKAGE_BUGREPORT := arto@bendiken.net
PACKAGE_URL       := http://lmdbxx.sourceforge.net/

DESTDIR  :=
PREFIX   := /usr/local

CPPFLAGS := -I.
CXXFLAGS := -g -O2 -std=c++17 -Wall -Werror -fsanitize=address -fsanitize=undefined
LDFLAGS  := -fsanitize=address -fsanitize=undefined
LDADD    := -llmdb

includedir = $(PREFIX)/include

MKDIR         := mkdir -p
RM            := rm -f
INSTALL       := install -c
INSTALL_DATA   = $(INSTALL) -m 644
INSTALL_HEADER = $(INSTALL_DATA)

DISTFILES := AUTHORS CREDITS INSTALL README TODO UNLICENSE VERSION \
             Makefile check.cc example.cc lmdb++.h

default: help

help:
	@echo 'Install the <lmdb++.h> header file using `make install`.'

check: check.o testdb
	$(CXX) $(LDFLAGS) -o $@ check.o $(LDADD) && ./$@

testdb:
	$(MKDIR) testdb/
	$(RM) testdb/data.mdb testdb/lock.mdb

example: example.o
	$(MKDIR) example.mdb/
	$(CXX) $(LDFLAGS) -o $@ $^ $(LDADD) && ./$@

%.o: %.cc lmdb++.h
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $<

installdirs:
	$(MKDIR) $(DESTDIR)$(includedir)

install: lmdb++.h installdirs
	$(INSTALL_HEADER) $< $(DESTDIR)$(includedir)

uninstall:
	$(RM) $(DESTDIR)$(includedir)/lmdb++.h

clean:
	$(RM) README.html check example $(PACKAGE_TARSTRING).tar.* *.o *~

doxygen: README.md
	doxygen Doxyfile
	sed -e 's/Main Page/a C++11 wrapper for LMDB/'                    \
	    -e 's/lmdb++ Documentation/lmdb++: a C++11 wrapper for LMDB/' \
	    -i.orig .doxygen/html/index.html

maintainer-clean: clean

maintainer-doxygen: doxygen
	rsync -az .doxygen/html/ bendiken@web.sourceforge.net:/home/project-web/lmdbxx/htdocs/

dist:
	tar -chJf $(PACKAGE_TARSTRING).tar.xz \
	    --transform 's,^,$(PACKAGE_TARSTRING)/,' $(DISTFILES)
	tar -chjf $(PACKAGE_TARSTRING).tar.bz2 \
	    --transform 's,^,$(PACKAGE_TARSTRING)/,' $(DISTFILES)
	tar -chzf $(PACKAGE_TARSTRING).tar.gz \
	    --transform 's,^,$(PACKAGE_TARSTRING)/,' $(DISTFILES)

.PHONY: help check example installdirs install uninstall clean doxygen maintainer-doxygen dist testdb

=== debian/changelog ===
nheko (0.12.0+~0.10.0+~1.0.0+~0.3.1-4) unstable; urgency=medium

  * add patches cherry-picked upstream:
    + fix build against fmt 11
    + break up large key requests into smaller ones;
      closes: bug#f6788ec, thanks to Shengqi Chen
    + add more options for screen sharing frame rate
  * update copyright info: update coverage
  * depend on qt6-svg-plugins;
    closes: bug#1089609, thanks to Russell Coker and ZenWalker

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 12 Jan 2025 18:30:29 +0100

nheko (0.12.0+~0.10.0+~1.0.0+~0.3.1-3) unstable; urgency=medium

  * stop (build-)depend explicitly om qml6 packages;
    stop depend on gstreamer1.0-qt5;
    recommend (not depend on) gstreamer1.0-nice
  * override qmldeps for
    missing modules nheko Qt6GLVideoItem Qt6D3D11VideoItem

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 09 Nov 2024 12:52:14 +0100

nheko (0.12.0+~0.10.0+~1.0.0+~0.3.1-2) unstable; urgency=medium

  * auto-resolve dependencies on qml modules,
     tolerating errors as GStreamer qml modules are missing;
    build-depend on dh-sequence-qmldeps qml6-module-qtmultimedia

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 30 Oct 2024 06:34:04 +0100

nheko (0.12.0+~0.10.0+~1.0.0+~0.3.1-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update watch file:
    + bump versions for mtxclient coeurl
    + modernize search runes for coeurl
  * drop patch cherry-picked upstream,
    obsoleted by upstream changes
  * unfuzz patches
  * update copyright info: update coverage
  * build against Qt6 libraries
  * stop build-depend on libnice-dev libsodium-dev zlib1g-dev
  * suggest (not recommend) kimageformat6-plugins
  * update DEP-3 patch headers
  * add patches cherry-picked upstream:
    + fix disabling a room ping
    + fix avatar change rendering
  * declare compliance with Debian Policy 4.7.0
  * relax to build-depend unversioned
    when version is satisfied in Debian stable

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 14 Jun 2024 12:35:40 +0200

nheko (0.11.3+~0.9.2+~1.0.0+~0.3.0-2) unstable; urgency=medium

  * revive and acknowledge NMU;
    closes: bug#1042967, thanks to Boyuan Yang
  * revert to do parallel build,
    and relax compiler optimization for armel and armhf
    same as other weak arches

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 04 Apr 2024 21:17:09 +0200

nheko (0.11.3-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/rules: Force non-parallel build, hopefully fix OOM with
    armhf buildd build.
  * debian/patches/:
    + 0003-Fix-voip-defaults-being-incorrect-because-OS-constan.patch:
      Apply upstream fix on launch crashes with arm64. (Closes: #1042967)

 -- Boyuan Yang <byang@debian.org>  Mon, 18 Dec 2023 12:54:11 -0500

=== debian/control ===
Source: nheko
Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@alioth-lists.debian.net>
Uploaders:
 Hubert Chathi <uhoreg@debian.org>,
 Jonas Smedegaard <dr@jones.dk>,
Section: net
Priority: optional
Build-Depends:
 asciidoc-base,
 cmake,
 debhelper-compat (=13),
 dh-exec,
 dh-sequence-qmldeps,
 libcmark-dev,
 libcpp-httplib-dev,
 libcurl4-openssl-dev,
 libevent-dev,
 libfmt-dev,
 libgstreamer-plugins-bad1.0-dev,
 libgstreamer-plugins-base1.0-dev,
 libgstreamer1.0-dev,
 libkdsingleapplication-qt6-dev,
 liblmdb-dev,
 libolm-dev,
 libre2-dev,
 libspdlog-dev,
 libssl-dev,
 libxcb-ewmh-dev,
 nlohmann-json3-dev,
 qt6-base-dev,
 qt6-base-private-dev,
 qt6-declarative-dev,
 qt6-declarative-private-dev,
 qt6-multimedia-dev,
 qt6-svg-dev,
 qt6-tools-dev,
 qtkeychain-qt6-dev,
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/matrix-team/nheko
Vcs-Git: https://salsa.debian.org/matrix-team/nheko.git
Homepage: https://github.com/Nheko-Reborn/nheko
Rules-Requires-Root: no

Package: nheko
Architecture: any
Depends:
 qt6-svg-plugins,
 ${misc:Depends},
 ${qml6:Depends},
 ${shlibs:Depends},
Recommends:
 ca-certificates,
 fonts-noto-color-emoji,
 gnome-keyring | kwalletmanager,
 gstreamer1.0-libcamera,
 gstreamer1.0-nice,
 gstreamer1.0-pipewire,
 gstreamer1.0-plugins-bad,
 gstreamer1.0-qt6,
 qt6-image-formats-plugins,
Suggests:
 gstreamer1.0-vaapi,
 kimageformat6-plugins,
Description: desktop IM client for the Matrix protocol
 Nheko is a Qt-based chat client for Matrix, an open, federated communications
 protocol.  The motivation behind the project is to provide a native desktop
 app for Matrix that feels more like a mainstream chat app and less like an IRC
 client.

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-$1/,\
dversionmangle=auto \
https://github.com/Nheko-reborn/nheko/tags \
.*?@ANY_VERSION@@ARCHIVE_EXT@ group

opts=\
component=mtxclient,\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-mtxclient-$1/,\
dversionmangle=auto \
https://github.com/Nheko-Reborn/mtxclient/tags \
.*?v(0\.10\.0)@ARCHIVE_EXT@ group

opts=\
component=lmdbxx,\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-lmdbxx-$1/,\
dversionmangle=auto \
https://github.com/Nheko-Reborn/lmdbxx/tags \
.*?(1\.0\.0)@ARCHIVE_EXT@ group

opts=\
component=coeurl,\
searchmode=plain,\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-coeurl-$1/,\
dversionmangle=auto \
https://nheko.im/nheko-reborn/coeurl/tags?sort=updated_desc \
-/archive/v\d[\d.]+/coeurl-v(0\.3\.1)@ARCHIVE_EXT@ group

## nheko 0.12.1%2B~0.10.1%2B~1.0.0%2B~0.3.1

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: nheko
-Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@alioth-lists.debian.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@alioth-lists.debian.net>
 Uploaders:
  Hubert Chathi <uhoreg@debian.org>,
  Jonas Smedegaard <dr@jones.dk>,
 Section: net
-Priority: optional
 Build-Depends:
  asciidoc-base,
  cmake,
@@ -35,11 +35,10 @@
  qt6-svg-dev,
  qt6-tools-dev,
  qtkeychain-qt6-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/matrix-team/nheko
 Vcs-Git: https://salsa.debian.org/matrix-team/nheko.git
 Homepage: https://github.com/Nheko-Reborn/nheko
-Rules-Requires-Root: no
 
 Package: nheko
 Architecture: any

## nheko 0.12.1+~0.10.1+~1.0.0+~0.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.13..3.21)
+cmake_minimum_required(VERSION 3.13...3.21)
 
 option(APPVEYOR_BUILD "Build on appveyor" OFF)
 option(CI_BUILD "Set when building in CI. Enables -Werror where possible" OFF)
@@ -25,8 +25,8 @@
 option(HUNTER_ENABLED "Enable Hunter package manager" OFF)
 include("cmake/HunterGate.cmake")
 HunterGate(
-    URL "https://github.com/cpp-pm/hunter/archive/v0.25.5.tar.gz"
-    SHA1 "a20151e4c0740ee7d0f9994476856d813cdead29"
+    URL "https://github.com/cpp-pm/hunter/archive/v0.26.1.tar.gz"
+    SHA1 "e41ac7a18c49b35ebac99ff2b5244317b2638a65"
     LOCAL
 )
 
@@ -50,6 +50,7 @@
 project(nheko LANGUAGES CXX C)
 
 option(USE_BUNDLED_SPDLOG "Use the bundled version of spdlog." ${HUNTER_ENABLED})
+option(USE_BUNDLED_FMT "Use the bundled version of {fmt}." ${HUNTER_ENABLED})
 option(USE_BUNDLED_OLM "Use the bundled version of libolm." ${HUNTER_ENABLED})
 option(USE_BUNDLED_GTEST "Use the bundled version of Google Test." ${HUNTER_ENABLED})
 option(USE_BUNDLED_CMARK "Use the bundled version of cmark." ${HUNTER_ENABLED})
@@ -114,7 +115,7 @@
 
 set(CPACK_PACKAGE_VERSION_MAJOR "0")
 set(CPACK_PACKAGE_VERSION_MINOR "12")
-set(CPACK_PACKAGE_VERSION_PATCH "0")
+set(CPACK_PACKAGE_VERSION_PATCH "1")
 set(PROJECT_VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR})
 set(PROJECT_VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR})
 set(PROJECT_VERSION_PATCH ${CPACK_PACKAGE_VERSION_PATCH})
@@ -179,6 +180,12 @@
     find_package(PkgConfig REQUIRED) 
     pkg_check_modules(libcurl REQUIRED IMPORTED_TARGET libcurl)
 endif()
+
+# fmt
+if(USE_BUNDLED_FMT)
+    hunter_add_package_safe(fmt)
+endif()
+find_package(fmt 8.0.0 CONFIG REQUIRED)
 
 # spdlog
 if(USE_BUNDLED_SPDLOG)
@@ -351,13 +358,3 @@
 configure_file(cmake/nheko.h config/nheko.h)
 
 #
-# Declare source and header files.
-#
-set(SRC_FILES
-    # Emoji
-    src/emoji/Provider.cpp
-    src/emoji/Provider.h
-    src/emoji/Emoji.cpp
-    src/emoji/Emoji.h
-
-    # Timeline

=== Makefile ===
FILES=`find lib include tests examples -type f -type f \( -iname "*.cpp" -o -iname "*.hpp" \)`

SYNAPSE_IMAGE="matrixdotorg/synapse:v1.135.0"

DEPS_BUILD_DIR=.deps
DEPS_SOURCE_DIR=deps

help: ## This help message
	@grep -E '^[0-9a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) | sort | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-20s\033[0m %s\n", $$1, $$2}'
	@# Change the digit following by an 's' to adjust the width of the help text

third-party: ## Build & install third party dependencies
	@cmake -GNinja -H${DEPS_SOURCE_DIR} -B${DEPS_BUILD_DIR} -DCMAKE_BUILD_TYPE=Release -DUSE_BUNDLED_BOOST=OFF -DUSE_BUNDLED_JSON=OFF
	@cmake --build ${DEPS_BUILD_DIR}

debug: ## Create a debug build
	@cmake -GNinja -H. -Bbuild \
		-DCMAKE_BUILD_TYPE=Debug \
		-DCMAKE_EXPORT_COMPILE_COMMANDS=1 \
		-DOPENSSL_ROOT_DIR=/usr/local/opt/openssl \
		-DCMAKE_INSTALL_PREFIX=${DEPS_BUILD_DIR}/usr
	@cmake --build build

release: ## Create an optimized build
	@cmake -GNinja -H. -Bbuild \
		-DCMAKE_BUILD_TYPE=Release \
		-DOPENSSL_ROOT_DIR=/usr/local/opt/openssl \
		-DCMAKE_INSTALL_PREFIX=${DEPS_BUILD_DIR}/usr
	@cmake --build build

test: ## Run the tests
	@cd build/ && GTEST_COLOR=1 ctest --verbose

asan: ## Create a debug build using address sanitizers
	@cmake -GNinja -H. -Bbuild \
		-DCMAKE_BUILD_TYPE=Debug \
		-DOPENSSL_ROOT_DIR=/usr/local/opt/openssl \
		-DCMAKE_INSTALL_PREFIX=${DEPS_BUILD_DIR}/usr \
		-DASAN=1
	@cmake --build build

image:
	docker build -t mtxclient-dev .

synapse: ## Start a synapse instance on docker
	@mkdir -p data
	@chmod 0777 data
	@docker run -v `pwd`/data:/data --rm \
		-e SYNAPSE_SERVER_NAME=localhost -e SYNAPSE_REPORT_STATS=no ${SYNAPSE_IMAGE} generate
	@./.ci/adjust-config.sh
	@docker run -d \
		--name synapse \
		-p 443:8008 \
		-p 8448:8008 \
		-p 8008:8008 \
		-p 8009:8009 \
		-v `pwd`/data:/data ${SYNAPSE_IMAGE}
	@echo Waiting for synapse to start...
	@until curl -s -f -k https://localhost:443/_matrix/client/versions; do echo "Checking ..."; sleep 2; done
	@echo Register alice
	@docker exec synapse /bin/sh -c 'register_new_matrix_user --admin -u alice -p secret -c /data/homeserver.yaml http://localhost:8009'
	@echo Register bob
	@docker exec synapse /bin/sh -c 'register_new_matrix_user --admin -u bob -p secret -c /data/homeserver.yaml http://localhost:8009'
	@echo Register carl
	@docker exec synapse /bin/sh -c 'register_new_matrix_user --admin -u carl -p secret -c /data/homeserver.yaml http://localhost:8009'
	@echo Register presence
	@docker exec synapse /bin/sh -c 'register_new_matrix_user --admin -u presence -p secret -c /data/homeserver.yaml http://localhost:8009'
	@echo Register presencesync
	@docker exec synapse /bin/sh -c 'register_new_matrix_user --admin -u presencesync -p secret -c /data/homeserver.yaml http://localhost:8009'

stop-synapse: ## Stop any running instance of synapse
	@rm -rf ./data/*
	@docker rm -f synapse 2>&1>/dev/null

restart: stop-synapse synapse

lint: ## Run clang-format on the source code
	@clang-format -i ${FILES} && git diff --exit-code

clean: ## Delete the build directory
	rm -rf build

=== meson_options.txt ===
option('tests', type : 'boolean', value : false, description : 'Build the tests')
option('examples', type : 'boolean', value : false, description : 'Build the examples')

=== examples/CMakeLists.txt ===
include_directories(../tests)

add_executable(room_feed room_feed.cpp)
target_link_libraries(room_feed MatrixClient::MatrixClient)

add_executable(media_downloader media_downloader.cpp)
target_link_libraries(media_downloader MatrixClient::MatrixClient)

add_executable(memberstats memberstats.cpp)
target_link_libraries(memberstats MatrixClient::MatrixClient)

add_executable(simple_bot simple_bot.cpp)
target_link_libraries(simple_bot MatrixClient::MatrixClient)

add_executable(crypto_bot crypto_bot.cpp)
target_link_libraries(crypto_bot
                      spdlog::spdlog
                      MatrixClient::MatrixClient
                      Olm::Olm)

  add_executable(online_backup_exporter online_backup_exporter.cpp)
  target_link_libraries(online_backup_exporter MatrixClient::MatrixClient)

=== man/CMakeLists.txt ===
# Uses either a2x from asciidoc or asciidoctor to compile the man page.

include(GNUInstallDirs)

configure_file("${PROJECT_NAME}.1.adoc" "${PROJECT_NAME}.1.adoc" @ONLY)

find_program (ASCIIDOC_COMPILER a2x)
if (NOT ASCIIDOC_COMPILER)
  find_program (ASCIIDOCTOR_COMPILER asciidoctor)
  if(NOT ASCIIDOCTOR_COMPILER)
    message(FATAL_ERROR
      "Could not find asciidoc (a2x) or asciidoctor. "
      "Man page generation not possible.")
  endif()
endif()

if(ASCIIDOC_COMPILER)
  message(STATUS "Using asciidoc compiler at ${ASCIIDOC_COMPILER}")

  add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.1"
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    DEPENDS "${PROJECT_NAME}.1.adoc"
    COMMAND "${ASCIIDOC_COMPILER}"
    ARGS
    "--doctype=manpage"
    "--format=manpage"
    "--no-xmllint"
    "${PROJECT_NAME}.1.adoc")
endif()

if(ASCIIDOCTOR_COMPILER)
  message(STATUS "Using asciidoctor compiler at ${ASCIIDOCTOR_COMPILER}")

  add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.1"
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    DEPENDS "${PROJECT_NAME}.1.adoc"
    COMMAND "${ASCIIDOCTOR_COMPILER}"
    ARGS "--backend=manpage" "--doctype=manpage" "${PROJECT_NAME}.1.adoc")
endif()

if(ASCIIDOC_COMPILER OR ASCIIDOCTOR_COMPILER)
  add_custom_target(man ALL DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.1")

  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.1
    DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
endif()

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12...3.13)


set(
	CMAKE_TOOLCHAIN_FILE
	"${CMAKE_CURRENT_LIST_DIR}/../toolchain.cmake"
	CACHE
	FILEPATH
	"Default toolchain"
	)
set(CMAKE_CXX_STANDARD 17 CACHE STRING "C++ standard")
set(CMAKE_CXX_STANDARD_REQUIRED ON CACHE BOOL "Require C++ standard to be supported")
set(CMAKE_POSITION_INDEPENDENT_CODE ON CACHE BOOL "compile as PIC by default")

option(HUNTER_ENABLED "Enable Hunter package manager" OFF)
include("../cmake/HunterGate.cmake")
HunterGate(
	URL "https://github.com/cpp-pm/hunter/archive/v0.24.8.tar.gz"
	SHA1 "ca7838dded9a1811b04ffd56175f629e0af82d3d"
)

project(coeurl-cmake-buildtest)

include(FetchContent)
FetchContent_Declare(
	coeurl
	GIT_REPOSITORY "${CMAKE_CURRENT_LIST_DIR}/.."
	GIT_TAG        HEAD
	)
FetchContent_MakeAvailable(coeurl)

=== debian/changelog ===
nheko (0.12.1+~0.10.1+~1.0.0+~0.3.1-2) unstable; urgency=medium

  * add patch cherry-picked upstream
    to fix most reply rendering issues with qt 6.9.2
  * update watch file: use file format 5

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 24 Sep 2025 01:40:06 +0200

nheko (0.12.1+~0.10.1+~1.0.0+~0.3.1-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update watch file: bump version prefix for embedded mtxclient
  * drop patches cherry-picked upstream, obsoleted by upstream changes
  * unfuzz patches

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 10 Aug 2025 15:32:00 +0200

nheko (0.12.0+~0.10.0+~1.0.0+~0.3.1-6) unstable; urgency=medium

  * no-changes source-only upload to enable testing migration

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 10 Aug 2025 14:08:45 +0200

nheko (0.12.0+~0.10.0+~1.0.0+~0.3.1-5) experimental; urgency=medium

  * add patch cherry-picked upstream
    to fix verification with new Element clients
  * declare compliance with Debian Policy 4.7.2

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 03 Aug 2025 11:33:55 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: nheko
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@alioth-lists.debian.net>
+Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@alioth-lists.debian.net>
 Uploaders:
  Hubert Chathi <uhoreg@debian.org>,
  Jonas Smedegaard <dr@jones.dk>,
 Section: net
+Priority: optional
 Build-Depends:
  asciidoc-base,
  cmake,
@@ -35,10 +35,11 @@
  qt6-svg-dev,
  qt6-tools-dev,
  qtkeychain-qt6-dev,
-Standards-Version: 4.7.3
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/matrix-team/nheko
 Vcs-Git: https://salsa.debian.org/matrix-team/nheko.git
 Homepage: https://github.com/Nheko-Reborn/nheko
+Rules-Requires-Root: no
 
 Package: nheko
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=6

# reduce risk of out-of-memory issues during build for weak arches
ifneq (,$(filter $(DEB_HOST_ARCH),armel armhf mips mipsel sh4 hppa))
DEB_CFLAGS_MAINT_STRIP = -g1
DEB_CXXFLAGS_MAINT_STRIP = -g1
DEB_CFLAGS_MAINT_APPEND = -g0
DEB_CXXFLAGS_MAINT_APPEND = -g0
DEB_CPPFLAGS_MAINT_APPEND = --param ggc-min-expand=10
ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
DEB_CFLAGS_MAINT_STRIP += -O2
DEB_CXXFLAGS_MAINT_STRIP += -O2
DEB_CFLAGS_MAINT_APPEND += -Os
DEB_CXXFLAGS_MAINT_APPEND += -Os
endif
endif

%:
	dh $@ --buildsystem=cmake --builddirectory=build

# all done in build: build of earlier parts needed to configure later parts
override_dh_auto_configure:

override_dh_auto_build:
	dh_auto_configure --sourcedirectory=coeurl --builddirectory=.deps/coeurl
	dh_auto_build --sourcedirectory=coeurl --builddirectory=.deps/coeurl
	dh_auto_configure --sourcedirectory=mtxclient --builddirectory=.deps/mtxclient -- -DBUILD_LIB_TESTS=OFF -DBUILD_SHARED_LIBS=OFF -DBUILD_LIB_EXAMPLES=OFF -Dcoeurl_DIR=$(CURDIR)/.deps/coeurl
	dh_auto_build --sourcedirectory=mtxclient --builddirectory=.deps/mtxclient
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=RelWithDebInfo -DBUILD_LIB_EXAMPLES=OFF -DUSE_BUNDLED_CPPHTTPLIB=OFF -DLMDBXX_INCLUDE_DIR=$(CURDIR)/lmdbxx -Dcoeurl_DIR=$(CURDIR)/.deps/coeurl -DMatrixClient_DIR=$(CURDIR)/.deps/mtxclient
	dh_auto_build

override_dh_auto_test:
	dh_auto_test --sourcedirectory=coeurl --builddirectory=.deps/coeurl
	dh_auto_test --sourcedirectory=mtxclient --builddirectory=.deps/mtxclient
	dh_auto_test

=== debian/watch ===
version: 5
Version-Schema: group
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

Template: Github
Owner: Nheko-reborn
Project: nheko
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@SEMANTIC_VERSION@

Component: mtxclient
Template: Github
Owner: Nheko-reborn
Project: mtxclient

Component: lmdbxx
Template: Github
Owner: Nheko-reborn
Project: lmdbxx

Component: coeurl
Template: Gitlab
Dist: https://nheko.im/nheko-reborn/coeurl
version-Mangle: s/v//
